# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cras_msgs/PowerMeasurement.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import cras_msgs.msg
import genpy

class PowerMeasurement(genpy.Message):
  _md5sum = "acef8a11a2a0421c98a65e6fc99a2fd1"
  _type = "cras_msgs/PowerMeasurement"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Single power measurement.
 
Power data  # Power value.
float64 variance  # Variance of the measurement (in Watt^2). If not known or relevant, use 0.
duration sample_duration  # Duration of the measurement. If not known or relevant, use 0.

================================================================================
MSG: cras_msgs/Power
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: Czech Technical University in Prague

# Mechanical or electrical power value.
 
float64 power  # Power value (in Watts).
"""
  __slots__ = ['data','variance','sample_duration']
  _slot_types = ['cras_msgs/Power','float64','duration']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       data,variance,sample_duration

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PowerMeasurement, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = cras_msgs.msg.Power()
      if self.variance is None:
        self.variance = 0.
      if self.sample_duration is None:
        self.sample_duration = genpy.Duration()
    else:
      self.data = cras_msgs.msg.Power()
      self.variance = 0.
      self.sample_duration = genpy.Duration()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2d2i().pack(_x.data.power, _x.variance, _x.sample_duration.secs, _x.sample_duration.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = cras_msgs.msg.Power()
      if self.sample_duration is None:
        self.sample_duration = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.data.power, _x.variance, _x.sample_duration.secs, _x.sample_duration.nsecs,) = _get_struct_2d2i().unpack(str[start:end])
      self.sample_duration.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2d2i().pack(_x.data.power, _x.variance, _x.sample_duration.secs, _x.sample_duration.nsecs))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.data is None:
        self.data = cras_msgs.msg.Power()
      if self.sample_duration is None:
        self.sample_duration = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.data.power, _x.variance, _x.sample_duration.secs, _x.sample_duration.nsecs,) = _get_struct_2d2i().unpack(str[start:end])
      self.sample_duration.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d2i = None
def _get_struct_2d2i():
    global _struct_2d2i
    if _struct_2d2i is None:
        _struct_2d2i = struct.Struct("<2d2i")
    return _struct_2d2i
